// VERSION 4.2pure
//
// removed: sm_gungame_enabled
// removed: sm_gungame_nadelasereffect
// removed: all spawnprotection (sm_gungame_spawnprotect, sm_gungame_spawnprotect_time, sm_gungame_spawnprotect_message)
// removed: all bazooka effects (sm_gungame_bazooka_shake_effect, sm_gungame_bazooka_shake_effect_amp, sm_gungame_bazooka_shake_effect_dur)
// removed: sm_gungame_lastlevelcenterinfo
// removed: sm_gungame_spades, sm_gungame_spadespro, sm_gungame_turbo
// removed  all custom weapon lists (sm_gungame_custom ,....)
// removed: sm_gungame_runcommand
// removed  all Calls to the GG addons (join/win sound , overlays)
// removed: sm_gungame_rapidfirepistol
// removed: sm_gungame_votesoundfile
// removed  doulbejump feature (sm_gungame_doublejump_enabled, sm_gungame_doublejump_boost, sm_gungame_doublejump_max)
// removed: sm_gungame_teamwallremove_gameend
// removed: sm_gungame_roundend
// removed: sm_gungame_database_web, sm_gungame_database_winner, sm_gungame_helpurl
// removed: sm_gungame_rapidfirebazooka, sm_gungame_rapidfirebazooka_delay, sm_gungame_speclock
// removed: sm_gungame_runvoteenable, sm_gungame_bonustimevote
// removed: sm_gungame_health_on_levelup, sm_gungame_health_on_levelup_var
// removed: sm_gungame_bonustimekill (no need of sdkhooks now!!)
// VERSION 3.7pure
// changed random player class to rifleman (did not spam chat now !!)
// VERSION 3.8pure
// some fixes
// VERSION 3.9
// some changes in runcommand with spade & bonusround
// VERSION 4.0
// removed dodhooks
// VERSION 4.2
// added CallForwards for DOD Stats (OnLevelUp OnLevelDown OnLevelSteal OnGGWin )
// VERSION 4.3
// added a new check about weapon bug!
// VERSION 4.4
// changed getclientauthstring (690)
//

#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#define ALLIES	2
#define AXIS	3
#define PLUGIN_VERSION "4.4pure"

new votebeforeendvar = 0;
new g_iAmmo[MAXPLAYERS + 1];
new g_iAmount[MAXPLAYERS + 1];
new g_iClip;
new g_iLevel[MAXPLAYERS + 1]    = {1, ...};
new g_iLevels;
new g_iOffset;
new g_ggWinner = -1;
new g_iOldLevel[MAXPLAYERS + 1] = {1, ...};
new g_iWeapon[MAXPLAYERS + 1]   = {-1, ...};
new Handle:g_hHandicap = INVALID_HANDLE;
new Handle:g_hNextMap = INVALID_HANDLE;
new Handle:g_nades = INVALID_HANDLE;
new Handle:g_bonustime = INVALID_HANDLE;
new Handle:g_runspeed = INVALID_HANDLE;
new Handle:g_spadeknifehealth = INVALID_HANDLE;
new Handle:g_runvote = INVALID_HANDLE;
new Handle:g_votebeforeend = INVALID_HANDLE;
new Handle:g_votebeforeendlevel = INVALID_HANDLE;
new Handle:g_TeamLockGG = INVALID_HANDLE;
new Handle:g_CPdisable = INVALID_HANDLE;
new Handle:g_TeamWallRemoveGame = INVALID_HANDLE;
new Handle:g_gungame_punishment = INVALID_HANDLE;
new String:g_sPrefix[24]        = "\x04GG \x01";
new String:g_sSoundJoin[PLATFORM_MAX_PATH];
new String:g_sSoundLevelUp[PLATFORM_MAX_PATH];
new String:g_sSoundLevelDown[PLATFORM_MAX_PATH];
new String:g_sSoundLevelSteal[PLATFORM_MAX_PATH];
new String:g_sSoundWin[PLATFORM_MAX_PATH];
new String:g_sSoundvote[PLATFORM_MAX_PATH];
new String:g_sSoundLevelLast[PLATFORM_MAX_PATH];
new String:g_sWeapon[MAXPLAYERS + 1][16];
new String:FlagSnd[] = "ambient/flag.wav";
new bool:IsProtected[MAXPLAYERS+1] = false;
new bool:g_bEnabled = true;
new Float:g_fPosition[MAXPLAYERS + 1][3];
new Handle:OnLevelDown = INVALID_HANDLE;
new Handle:OnLevelSteal = INVALID_HANDLE;
new Handle:OnGGWin = INVALID_HANDLE;
new Handle:OnLevelUp = INVALID_HANDLE;

static const String:g_szObjectives[][] = {"dod_bomb_target","dod_capture_area"};
static const String:g_szTeamWalls[][] = {"func_team_wall","func_teamblocker"};

public Plugin:myinfo = {
	name        = "DoD:S GunGame",
	author      = "Darkranger (orig. by Tsunami), Feuersturm, Andersso and others",
	description = "DoD:S GunGame for SourceMod",
	version     = PLUGIN_VERSION,
	url         = "http://dodsplugins.com"
}

public OnPluginStart()
{
	CreateConVar("sm_gungame_version", PLUGIN_VERSION, "DoD:S GunGame for SourceMod", FCVAR_PLUGIN | FCVAR_REPLICATED | FCVAR_NOTIFY | FCVAR_DONTRECORD);
	g_hHandicap = CreateConVar("sm_gungame_handicap", "1", "Enable/disable Handicap mode", FCVAR_PLUGIN);
	g_bonustime    = CreateConVar("sm_gungame_bonustime",    "15", "Length of Bonusround", FCVAR_PLUGIN, true, 5.0, true, 60.0);
	g_nades    = CreateConVar("sm_gungame_maxnades",    "10", "How many frag grenades that are allowed", FCVAR_PLUGIN, true, 1.0, true, 99.0);
	g_runspeed    = CreateConVar("sm_gungame_melee_speed",    "1.2", "Speed on spade/knife level(and Bonusround)", FCVAR_PLUGIN, true, 1.0, true, 2.5);
	g_spadeknifehealth	 = CreateConVar("sm_gungame_spadeknifehealth", "120", "Health on Spade/Knife Level", FCVAR_PLUGIN, true, 100.0, true, 160.0);
	g_runvote    = CreateConVar("sm_gungame_runvote",    "sm_mapvote", "Vote Map Command that will be executed", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	g_votebeforeend    = CreateConVar("sm_gungame_votebeforeend",    "1", "Enable/disable SM Vote X weapons before last level", FCVAR_PLUGIN);
	g_votebeforeendlevel    = CreateConVar("sm_gungame_votebeforeend_levels",    "4", "Vote how many weapons before last level", FCVAR_PLUGIN, true, 1.0, true, 7.0);
	g_TeamLockGG    = CreateConVar("sm_gungame_teamlock",    "1", "Enable/disable autojoin class when selected a Team", FCVAR_PLUGIN);
	g_CPdisable		= CreateConVar("sm_gungame_cpdisable",   "1", "Enable(0)/disable(1) Control Point Icons, Flags and FlagSound", FCVAR_PLUGIN);
	g_TeamWallRemoveGame = CreateConVar("sm_gungame_teamwallremove_game", "1", "Enable/disable removing func_team_walls during Game", FCVAR_PLUGIN);
	g_gungame_punishment = CreateConVar("sm_gungame_punishment",  "0", "Type of team kill punishment. (0 = Disabled, 1 = Level loss, 2 = Give spade, 3 = Give Spade & Level loss, 4 = Give Spade & Give Health, 5 = Give Spade & Give Health & Level loss)", FCVAR_PLUGIN);

	g_iClip     = FindSendPropInfo("CBaseCombatWeapon", "m_iClip1");
	g_iOffset   = FindSendPropInfo("CBasePlayer",       "m_iAmmo");
	HookEvent("dod_round_start", Event_RoundStart);
	HookEvent("player_death",    Event_PlayerDeath);
	HookEvent("player_spawn",    Event_PlayerSpawn);
	HookEvent("player_team",     Event_PlayerTeam, EventHookMode_Post);
	RegConsoleCmd("drop", Command_Drop, "Block weapons from being dropped in DoD:S GunGame.");
	AutoExecConfig(true, "dod_gungame_config_pure", "dod_gungame_config_pure");
	LoadTranslations("dod_gungame_pure.phrases");
	AddAmbientSoundHook(AmbientSHook:HookFlagSound);

	OnLevelUp  = CreateGlobalForward("OnLevelUp",  ET_Event, Param_Cell);
	OnLevelDown  = CreateGlobalForward("OnLevelDown",  ET_Event, Param_Cell);
	OnLevelSteal = CreateGlobalForward("OnLevelSteal", ET_Event, Param_Cell);
	OnGGWin      = CreateGlobalForward("OnGGWin",      ET_Event, Param_Cell);
}

public OnClientPutInServer(client)
{
	g_iLevel[client] = 1;
	g_iOldLevel[client] = 1;
	g_iWeapon[client]  = -1;
}

public OnMapStart()
{
	g_hNextMap    = FindConVar("sm_nextmap");
	g_ggWinner = -1;
	LoadConfig();
	votebeforeendvar = 0;
	PrecacheSound(FlagSnd, true);
	ServerCommand("mp_limit_allies_rifleman -1");
	ServerCommand("mp_limit_axis_rifleman -1");
}

public OnRoundStart()
{
	RemoveFlagSound();
}

public OnConfigsExecuted()
{
	LoadConfig2();
}

public OnClientDisconnect(client)
{

}

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon)
{
   if ((g_ggWinner != -1) || StrEqual(g_sWeapon[g_iLevel[client]], "spade") || StrEqual(g_sWeapon[g_iLevel[client]], "amerknife"))
   {
		buttons & IN_SPEED &&  buttons & IN_FORWARD ? SetEntPropFloat(client, Prop_Send, "m_flStamina", 90.0):0;
		buttons & IN_SPEED &&  buttons & IN_FORWARD ? SetEntPropFloat(client, Prop_Send, "m_flLaggedMovementValue", GetConVarFloat(g_runspeed)):0;
   }
}

public OnGameFrame()
{
	if (g_bEnabled && g_ggWinner == -1)
	{
		for (new i    = 1, iAmmo, iAmount; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && IsPlayerAlive(i) && !StrEqual(g_sWeapon[g_iLevel[i]], "frag_ger") && !StrEqual(g_sWeapon[g_iLevel[i]], "frag_us"))
			{
				iAmmo     = g_iAmmo[GetLevel(i)], iAmount = g_iAmount[i];
				if (iAmmo > g_iOffset && GetEntData(i, iAmmo) <= iAmount)
				{
					SetEntData(i, iAmmo, iAmount * 2, _, true);
				}
			}
		}
	}
}

public Action:Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (g_bEnabled)
	{
		new iClient = GetClientOfUserId(GetEventInt(event, "userid"));
		if (GetClientTeam(iClient) > 1)
		{
			GetClientAbsOrigin(iClient, g_fPosition[iClient]);
			for (new i = 0, s; i < 5; i++)
			{
				if ((s = GetPlayerWeaponSlot(iClient, i)) != -1)
				{
					RemoveWeapon(iClient, s);
				}
			}
			if(g_ggWinner != -1)
			{
				GivePlayerItem(iClient, "weapon_spade");
				return;
			}
			new iLevel        = g_iLevel[iClient];
			g_iWeapon[iClient] = -1;
			PrintToChat(iClient, "%s%t", g_sPrefix, "Level", 4, iLevel, 1, 4, g_sWeapon[iLevel]);
			if((IsClientInGame(iClient)) && (IsPlayerAlive(iClient)))
			{
				GiveWeapon(iClient);
			}
			if (!StrEqual(g_sWeapon[iLevel], "amerknife") && !StrEqual(g_sWeapon[iLevel], "spade") && (IsClientInGame(iClient)))
			{
				GivePlayerItem(iClient, "weapon_spade");
			}
			if (IsValidClient(iClient))
			{
				CreateTimer(0.1, NoWeaponCheck, iClient, TIMER_FLAG_NO_MAPCHANGE);
			}
		}
	}
}

public Action:Event_PlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (g_bEnabled && g_ggWinner == -1)
	{
		decl Float:fPosition[3], String:sWeapon[16];
		new iAttackerID = GetEventInt(event, "attacker"),
				iClientID   = GetEventInt(event, "userid"),
				iAttacker   = GetClientOfUserId(iAttackerID),
				iClient     = GetClientOfUserId(iClientID);
		GetClientAbsOrigin(iClient, fPosition);
		GetEventString(event, "weapon", sWeapon, sizeof(sWeapon));

		if (IsValidEntity(g_iWeapon[iClient]))
		{
			RemoveWeapon(iClient, g_iWeapon[iClient]);
		}
		if (iAttacker == 0 || iAttacker == iClient)
		{
			if (g_iLevel[iClient] > 1)
			{
				g_iLevel[iClient]--;
				PrintToChatAll("%s%t", g_sPrefix, "Suicide", 4, iClient, 1);
				LogEvent("gg_leveldown",    iClientID);
				Call_StartForward(OnLevelDown);
				Call_PushCell(iClient);
				Call_Finish();

				if (!StrEqual(g_sSoundLevelDown,    ""))
				{
					EmitSoundToClient(iClient, g_sSoundLevelDown);
				}
			}
		}
		else if	((GetClientTeam(iAttacker) == GetClientTeam(iClient)) && (GetConVarInt(g_gungame_punishment) == 1))
		{
			if (IsClientInGame(iAttacker) && IsPlayerAlive(iAttacker))
			{
				if (g_iLevel[iAttacker] > 1)
				{
					g_iLevel[iAttacker]--;
					PrintToChatAll("%s%t", g_sPrefix, "Team Kill", 4, iAttacker, 1);
					LogEvent("gg_leveldown", iAttackerID);
					Call_StartForward(OnLevelDown);
					Call_PushCell(iAttacker);
					Call_Finish();
					if (!StrEqual(g_sSoundLevelDown,    ""))
					{
						EmitSoundToClient(iAttacker, g_sSoundLevelDown);
					}
					CreateTimer(0.2, Timer_Give, iAttacker, TIMER_FLAG_NO_MAPCHANGE);
				}
			}
		}
		else if ((GetClientTeam(iAttacker) == GetClientTeam(iClient)) && (GetConVarInt(g_gungame_punishment) == 2 || (GetConVarInt(g_gungame_punishment) == 4)))
		{
			if (IsClientInGame(iAttacker) && IsPlayerAlive(iAttacker) && !IsFakeClient(iAttacker))
			{
				CreateTimer(0.2, Spade_Loss, iAttacker, TIMER_FLAG_NO_MAPCHANGE);
			}
		}
		else if ((GetClientTeam(iAttacker) == GetClientTeam(iClient)) && (GetConVarInt(g_gungame_punishment) == 3 || (GetConVarInt(g_gungame_punishment) == 5)))
		{
			if (IsClientInGame(iAttacker) && IsPlayerAlive(iAttacker) && !IsFakeClient(iAttacker))
			{
				g_iLevel[iAttacker]--;
				PrintToChatAll("%s%t", g_sPrefix, "Team Kill", 4, iAttacker, 1);
				LogEvent("gg_leveldown", iAttackerID);
				Call_StartForward(OnLevelDown);
				Call_PushCell(iAttacker);
				Call_Finish();
				if (!StrEqual(g_sSoundLevelDown,    ""))
				{
					EmitSoundToClient(iAttacker, g_sSoundLevelDown);
				}
				CreateTimer(0.2, Spade_Loss, iAttacker, TIMER_FLAG_NO_MAPCHANGE);
			}
		}
		else if (GetClientTeam(iAttacker) != GetClientTeam(iClient) && (StrEqual(sWeapon, g_sWeapon[GetLevel(iAttacker)]) || StrEqual(sWeapon, "spade")))
		{
			if (fPosition[0] == g_fPosition[iClient][0] && fPosition[1] == g_fPosition[iClient][1])
			{
				PrintHintText(iAttacker, "%t", "AFK", iClient);
			}
			else if (g_iLevel[iAttacker]++ < g_iLevels)
			{
				if 	(StrEqual(sWeapon, "spade") && g_iLevel[iClient] > 1)
				{
					g_iLevel[iClient]--;
					PrintToChatAll("%s%t", g_sPrefix, "Steal", 4, iAttacker, 1, 4, iClient, 1);
					LogEvent("gg_levelsteal", iAttackerID);
					Call_StartForward(OnLevelSteal);
					Call_PushCell(iAttacker);
					Call_Finish();
					LogEvent("gg_leveldown",  iClientID);
					Call_StartForward(OnLevelDown);
					Call_PushCell(iClient);
					Call_Finish();

					if (!StrEqual(g_sSoundLevelSteal, ""))
					{
						EmitSoundToClient(iAttacker, g_sSoundLevelSteal);
					}
					if (!StrEqual(g_sSoundLevelDown,  ""))
					{
						EmitSoundToClient(iClient,   g_sSoundLevelDown);
					}
					if (g_iLevel[iAttacker] == g_iLevels)
					{
						EmitSoundToClient(iAttacker, g_sSoundLevelLast);
						PrintToChatAll("%s \x06%N \x04%t", g_sPrefix, iAttacker, "lastlevel");
						PrintCenterTextAll("%s %N %t", g_sPrefix, iAttacker, "lastlevel");
					}
				}
				else
				{
					LogEvent("gg_levelup",    iAttackerID);
					Call_StartForward(OnLevelUp);
					Call_PushCell(iAttacker);
					Call_Finish();

					if (!StrEqual(g_sSoundLevelUp,    ""))
					{
						EmitSoundToClient(iAttacker, g_sSoundLevelUp);
					}
					if (g_iLevel[iAttacker] == g_iLevels)
					{
						EmitSoundToClient(iAttacker, g_sSoundLevelLast);
						PrintToChatAll("%s \x06%N \x04%t", g_sPrefix, iAttacker, "lastlevel");
						PrintCenterTextAll("%s %N %t", g_sPrefix, iAttacker, "lastlevel");
					}
					if ((g_iLevel[iAttacker] == (g_iLevels - ((GetConVarInt(g_votebeforeendlevel) -1)))) && (votebeforeendvar == 0) && (GetConVarFloat(g_votebeforeend) == 1))
					{
						ServerCommand("sm_mapvote_dontchange 0");
						ServerCommand("sm_mapvote_extend 0");
						ServerCommand("sm_mapvote_endvote 0");
						decl String:Runvote[256];
						GetConVarString(g_runvote, Runvote, sizeof(Runvote));
						ServerCommand("%s", Runvote);
						votebeforeendvar = 2;
						EmitSoundToAll(g_sSoundvote);
					}
				}

				new iLeader  = GetLeader(), iLevel = g_iLevel[iAttacker];
				if (IsPlayerAlive(iAttacker))
				{
					PrintToChat(iAttacker,   "%s%t", g_sPrefix, "Weapon",     4, g_sWeapon[iLevel]);
				}
				if (iLeader == iAttacker)
				{
					PrintToChatAll("%s%t", g_sPrefix, "Leader", 4, iAttacker, 1, 4, iLevel, 1);
				}
				else
				{
				new iLead  = g_iLevel[iLeader] - iLevel;
				if (iLead  > 0)
					{
					PrintToChat(iAttacker, "%s%t", g_sPrefix, "Difference", 4, iLead, 1, iLead == 1 ? "" : "s");
					}
				}
				CreateTimer(0.2, Timer_Give, iAttacker, TIMER_FLAG_NO_MAPCHANGE);
			}
			else
			{
			 	if(g_ggWinner == -1)
				{
					g_ggWinner = iAttacker;
					decl String:sNextMap[32];
					GetConVarString(g_hNextMap, sNextMap, sizeof(sNextMap));
					PrintToChatAll("%s%t", g_sPrefix, "Win", 4, iAttacker, 1, 4, sNextMap);
					Show_ggWinner(iAttacker);
					LogEvent("gg_win", iAttackerID);
					Call_StartForward(OnGGWin);
					Call_PushCell(iAttacker);
					Call_Finish();
					if (FindPluginByFile("dods_bots.smx") != INVALID_HANDLE)
					{
						ServerCommand("sm plugins unload dods_bots.smx");
					}
					CreateTimer(GetConVarFloat(g_bonustime), Timer_EndGame, TIMER_FLAG_NO_MAPCHANGE);
					if (!StrEqual(g_sSoundWin, ""))
					{
						EmitSoundToAll(g_sSoundWin);
					}
					for(new client = 1; client <= MaxClients; client++)
					{
						if(IsClientInGame(client) && IsPlayerAlive(client) && !IsFakeClient(client))
						{
						for (new i = 0, s; i < 5; i++)
							{
								if ((s = GetPlayerWeaponSlot(client, i)) != -1)
								{
									RemoveWeapon(client, s);
								}
							}
						GivePlayerItem(client, "weapon_spade");
						}
						if(IsClientInGame(client) && IsPlayerAlive(client) && IsFakeClient(client))
						{
							KickClient(client);
						}
					}
					// KICK BOTS FROM SPEC
					for(new client = 1; client <= MaxClients; client++)
					{
						if(IsClientInGame(client) && IsFakeClient(client))
						{
							KickClient(client);
						}
					}
				}
			}
		}
	}
}

public OnClientPostAdminCheck(client)
{
	IsProtected[client] = false;
	if (g_bEnabled && g_ggWinner == -1 && !StrEqual(g_sSoundJoin, ""))
	{
		EmitSoundToClient(client, g_sSoundJoin);
	}
	new iClients  = GetTeamClientCount(2) + GetTeamClientCount(3), iLevel = 0;
	if (GetConVarBool(g_hHandicap) && iClients > 0)
	{
		for (new i  = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && GetClientTeam(i) > 1)
			{
				iLevel += GetLevel(i);
			}
		}
		g_iLevel[client] = iLevel / iClients;
	}
	else
	{
		g_iLevel[client] = 1;
	}
	g_iWeapon[client]  = -1;
}

public MenuHandler_Give(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Select)
	{
		GiveWeapon(param1);
	}
}

public Action:Command_Drop(client, args)
{
	return g_bEnabled ? Plugin_Handled : Plugin_Continue;
}


public Action:Timer_MapVote(Handle:timer)
{
	decl String:Runvote[256];
	GetConVarString(g_runvote, Runvote, sizeof(Runvote));
	ServerCommand("%s", Runvote);
}

public Action:Show_ggWinner(ggWinner)
{
	new Handle:ggWinnerMenu = INVALID_HANDLE;
	ggWinnerMenu = CreatePanel();
	decl String:menutitle[256];
	Format(menutitle, sizeof(menutitle), "DoD GunGame");
	SetPanelTitle(ggWinnerMenu, menutitle);
	DrawPanelItem(ggWinnerMenu, "", ITEMDRAW_SPACER);
	decl String:Winner[256];
	Format(Winner, sizeof(Winner), "%t %N", "win1phrase", ggWinner);
	DrawPanelText(ggWinnerMenu, Winner);
	DrawPanelItem(ggWinnerMenu, "", ITEMDRAW_SPACER);
	decl String:sNextMap[32];
	GetConVarString(g_hNextMap, sNextMap, sizeof(sNextMap));
	decl String:NextMap[256];
	Format(NextMap, sizeof(NextMap), "%t %s", "win2phrase", sNextMap);
	DrawPanelText(ggWinnerMenu, NextMap);
	DrawPanelItem(ggWinnerMenu, "", ITEMDRAW_SPACER);
	SetPanelCurrentKey(ggWinnerMenu, 10);
	DrawPanelItem(ggWinnerMenu, "Close", ITEMDRAW_CONTROL);
	for(new i = 1; i <= MaxClients; i++)
	{
		if(IsClientInGame(i))
		{
			SendPanelToClient(ggWinnerMenu, i, Handle_ggWinnerMenu, 14);
		}
	}
}

public Handle_ggWinnerMenu(Handle:TeamStatsMenu, MenuAction:action, client, itemNum)
{
}


public Action:Event_RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	new entity = -1;
	if (GetConVarInt(g_CPdisable) == 1)
	{
		for (new i = 0; i < sizeof(g_szObjectives); i++)
		{
			while ((entity = FindEntityByClassname(entity, g_szObjectives[i])) != -1)
			{
				AcceptEntityInput(entity, "Kill");
			}
		}
		entity = -1;
		while ((entity = FindEntityByClassname(entity, "dod_control_point")) != -1)
		{
			AcceptEntityInput(entity, "HideModel");
		}
	}
	if (GetConVarInt(g_TeamWallRemoveGame) == 1)
	{
		entity = -1;
		for (new i = 0; i < sizeof(g_szTeamWalls); i++)
		{
			while ((entity = FindEntityByClassname(entity, g_szTeamWalls[i])) != -1)
			{
				AcceptEntityInput(entity, "Kill");
			}
		}
	}
}

public Action:Timer_EndGame(Handle:timer)
{
	new iGameEnd  = FindEntityByClassname(-1, "game_end");
	if (iGameEnd == -1 && (iGameEnd = CreateEntityByName("game_end")) == -1)
	{
		LogError("Unable to create entity \"game_end\"!");
	}
	else
	{
		AcceptEntityInput(iGameEnd, "EndGame");
	}
}

public Action:Timer_Give(Handle:timer,  any:client)
{
	if(IsClientInGame(client) && IsPlayerAlive(client))
	{
		GiveWeapon(client);
	}
}

public Action:Spade_Loss(Handle:timer,  any:client)
{
	if(IsClientInGame(client) && IsPlayerAlive(client))
	{
		for (new i = 0, s; i < 5; i++)
		{
			if ((s = GetPlayerWeaponSlot(client, i)) != -1)
			{
				RemoveWeapon(client, s);
			}
		}
		PrintToChatAll("%s \x06%N \x04%t", g_sPrefix, client, "Team Kill Spade");
		GivePlayerItem(client, "weapon_spade");
		if ((GetConVarInt(g_gungame_punishment) == 4) || (GetConVarInt(g_gungame_punishment) == 5))
		{
			SetEntityHealth(client, GetConVarInt(g_spadeknifehealth));
			PrintToChat(client, "PUNISHMENT HEALTH");
		}
	}
}

GiveWeapon(iClient)
{
	decl iWeapon, String:sWeapon[24];
	new iLevel = g_iOldLevel[iClient] = g_iLevel[iClient];
	if (IsValidClient(iClient))
	{
		CreateTimer(2.0, NoWeaponCheck_remove_giveweapon, iClient, TIMER_FLAG_NO_MAPCHANGE);
	}
	Format(sWeapon, sizeof(sWeapon), "weapon_%s", g_sWeapon[iLevel]);

	if (IsValidEntity(g_iWeapon[iClient]))
	{
		RemoveWeapon(iClient, g_iWeapon[iClient]);
	}
	iWeapon = GetPlayerWeaponSlot(iClient, 2);
	if (iWeapon != -1 && StrEqual(g_sWeapon[iLevel], "amerknife") || StrEqual(g_sWeapon[iLevel], "spade"))
	{
		RemoveWeapon(iClient, iWeapon);
	}
	g_iWeapon[iClient] = GivePlayerItem(iClient, sWeapon);
	if(StrEqual(g_sWeapon[iLevel], "frag_ger") || StrEqual(g_sWeapon[iLevel], "frag_us"))
	{
		SetEntData(iClient, g_iAmmo[iLevel], GetConVarInt(g_nades), _, true);
		PrintHintText(iClient, "%t", "grenades", GetConVarInt(g_nades));
		PrintToChat(iClient, "%s%t", g_sPrefix, "grenades", GetConVarInt(g_nades));
	}
	else if(StrEqual(g_sWeapon[iLevel], "spade") || StrEqual(g_sWeapon[iLevel], "amerknife"))
	{
		SetEntityHealth(iClient, GetConVarInt(g_spadeknifehealth));
		PrintToChat(iClient, "%s%t", g_sPrefix, "spadeknifehealth2", GetConVarInt(g_spadeknifehealth));
	}
	else
	{
		if (IsValidEntity(g_iWeapon[iClient]))
		{
			if ((g_iAmount[iClient] = GetEntData(g_iWeapon[iClient], g_iClip)) < 1)
			{
				g_iAmount[iClient]    = 1;
			}
			if (g_iAmmo[iLevel]     > 0)
			{
				SetEntData(iClient, g_iAmmo[iLevel], g_iAmount[iClient] * 2, _, true);
			}
		}
		else
		{
			if (IsValidClient(iClient))
			{
				CreateTimer(0.1, NoWeaponCheck_CLIP, iClient, TIMER_FLAG_NO_MAPCHANGE);
			}
		}	
	}
}

GetLeader()
{
	new iLeader = 0;
	for (new i  = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && g_iLevel[i] > g_iLevel[iLeader])
		{
			iLeader = i;
		}
	}

	return iLeader;
}

GetLevel(iClient)
{
	return g_iLevel[iClient];
}


LogEvent(const String:sName[], iUserID)
{
	decl String:sAuth[32];
	new iClient = GetClientOfUserId(iUserID);
	decl String:sTeam[32];
	if(GetClientTeam(iClient) == 2)
		{
		Format(sTeam, sizeof(sTeam), "Allies");
		}
		else
		{
		Format(sTeam, sizeof(sTeam), "Axis");
		}
	//GetClientAuthString(iClient, sAuth, sizeof(sAuth));
	GetClientAuthId(iClient, AuthId_Steam2, sAuth, sizeof(sAuth));
	LogToGame("\"%N<%d><%s><%s>\" triggered \"%s\"", iClient, iUserID, sAuth, sTeam, sName);
}

RemoveWeapon(iClient, iWeapon)
{
	if (IsValidClient(iClient))
	{
		CreateTimer(3.0, NoWeaponCheck_remove, iClient, TIMER_FLAG_NO_MAPCHANGE);
	}
	if (IsValidEdict(iWeapon))
	{
		RemovePlayerItem(iClient, iWeapon);
		//RemoveEdict(iWeapon);
		AcceptEntityInput(iWeapon, "kill");
	}
}


public Action:Event_PlayerTeam(Handle:event, const String:Name[], bool:DontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if((GetConVarInt(g_TeamLockGG) == 1) && (client != 0))
	{
		CreateTimer(0.1, randomjoinclassteam, client, TIMER_FLAG_NO_MAPCHANGE);
	}
}

public Action:randomjoinclassteam(Handle:timer, any:client)
{
	if (IsClientInGame(client))
	{
		FakeClientCommand(client, "cls_random");
		ShowVGUIPanel(client, "class_us", INVALID_HANDLE, false);
		ShowVGUIPanel(client, "class_ger", INVALID_HANDLE, false);
	}
}

public Action:randomjoinclass(Handle:timer, any:client)
{
	if (IsClientInGame(client))
	{
		FakeClientCommand(client, "cls_random");
		ShowVGUIPanel(client, "class_ger", INVALID_HANDLE, false);
		ShowVGUIPanel(client, "class_us", INVALID_HANDLE, false);
	}
}

RemoveFlagSound()
{
	if (GetConVarInt(g_CPdisable) == 1)
	{
		static soundOffset;
		new entity = -1;
		while ((entity = FindEntityByClassname(entity, "ambient_generic")) != -1)
		{
			if (!soundOffset && (soundOffset = FindDataMapOffs(entity, "m_iszSound")) == -1)
			{
				LogError("Error: Unable to find datamap offset: \"m_iszSound\"!");
				return;
			}
			decl String:sound[64];
			GetEntDataString(entity, soundOffset, sound, sizeof(sound));
			if (StrEqual(sound, FlagSnd))
			{
				AcceptEntityInput(entity, "Kill");
			}
		}
	}
}

public Action:HookFlagSound(String:sample[PLATFORM_MAX_PATH], &entity, &Float:volume, &level, &pitch, Float:pos[3], &flags, &Float:delay)
{
	if(StrEqual(sample, FlagSnd))
	{
		return Plugin_Stop;
	}
	return Plugin_Continue;
}

public OnPluginEnd()
{

}

public OnEventShutdown()
{
	UnhookEvent("player_spawn", Event_PlayerSpawn);
	UnhookEvent("player_death", Event_PlayerDeath);
	UnhookEvent("dod_round_start", Event_RoundStart);
}

LoadConfig()
{
	decl String:sPath[PLATFORM_MAX_PATH];
	new Handle:hConfig          = CreateKeyValues("GunGame");
	BuildPath(Path_SM, sPath, sizeof(sPath), "configs/gungame_sound_pure.txt");
	if (FileExists(sPath))
	{
		FileToKeyValues(hConfig, sPath);
		KvRewind(hConfig);
		KvJumpToKey(hConfig, "Sounds");
		KvGetString(hConfig, "Join",       g_sSoundJoin,       PLATFORM_MAX_PATH);
		KvGetString(hConfig, "LevelUp",    g_sSoundLevelUp,    PLATFORM_MAX_PATH);
		KvGetString(hConfig, "LevelDown",  g_sSoundLevelDown,  PLATFORM_MAX_PATH);
		KvGetString(hConfig, "LevelSteal", g_sSoundLevelSteal, PLATFORM_MAX_PATH);
		KvGetString(hConfig, "LevelLast", g_sSoundLevelLast,   PLATFORM_MAX_PATH);
		KvGetString(hConfig, "Win",        g_sSoundWin,        PLATFORM_MAX_PATH);
		KvGetString(hConfig, "vote",        g_sSoundvote,        PLATFORM_MAX_PATH);

		if (!StrEqual(g_sSoundJoin,       ""))
		{
			LoadSound(g_sSoundJoin);
		}
		if (!StrEqual(g_sSoundLevelUp,    ""))
		{
			LoadSound(g_sSoundLevelUp);
		}
		if (!StrEqual(g_sSoundLevelDown,  ""))
		{
			LoadSound(g_sSoundLevelDown);
		}
		if (!StrEqual(g_sSoundLevelSteal, ""))
		{
			LoadSound(g_sSoundLevelSteal);
		}
		if (!StrEqual(g_sSoundLevelLast, ""))
		{
			LoadSound(g_sSoundLevelLast);
		}
		if (!StrEqual(g_sSoundWin,        ""))
		{
			LoadSound(g_sSoundWin);
		}
		if (!StrEqual(g_sSoundvote,        ""))
		{
			LoadSound(g_sSoundvote);
		}
	}
	else
	{
		SetFailState("File Not Found: %s", sPath);
	}
	CloseHandle(hConfig);
}

LoadConfig2()
{
	decl String:sLevel[4], String:sPath[PLATFORM_MAX_PATH], String:sWeapon[16],
			 String:sWeapons[22][16] = {"colt", "p38", "c96", "garand", "k98", "k98_scoped", "m1carbine", "spring", "thompson", "mp40", "mp44", "bar", "30cal", "mg42", "bazooka", "pschreck", "frag_us", "frag_ger", "smoke_us", "smoke_ger", "riflegren_us", "riflegren_ger"};

	new  iLevel = 1,
	iOffsets[22] = { 4, 8, 12, 16, 20, 20, 24, 28, 32, 32, 32, 36, 40, 44, 48, 48, 52, 56, 68, 72, 84, 88},
	Handle:hConfig          = CreateKeyValues("GunGame");
	BuildPath(Path_SM, sPath, sizeof(sPath), "configs/gungame_pure.txt");
	if (FileExists(sPath))
	{
		for (new i = 0; i < sizeof(g_sWeapon); i++)
		{
			g_iAmmo[i]   = g_iOffset;
			g_sWeapon[i] = "";
		}
		FileToKeyValues(hConfig, sPath);
		KvJumpToKey(hConfig, "Levels");
		KvGetString(hConfig, "1", sWeapon, sizeof(sWeapon));

		while (!StrEqual(sWeapon, ""))
		{
			g_sWeapon[iLevel] = sWeapon;

			IntToString(++iLevel, sLevel, sizeof(sLevel));
			KvGetString(hConfig,  sLevel, sWeapon, sizeof(sWeapon));
		}
		KvRewind(hConfig);
		g_iLevels  = --iLevel;
		for (new i = 1, j; i <= g_iLevels; i++)
		{
			for (j   = 0; j < sizeof(sWeapons); j++)
			{
				if (StrEqual(g_sWeapon[i], sWeapons[j]))
				{
					g_iAmmo[i] += iOffsets[j];
					break;
				}
			}
		}
	}
	else
	{
		SetFailState("File Not Found: %s", sPath);
	}
	CloseHandle(hConfig);
}

LoadSound(const String:sFile[])
{
	decl String:sPath[PLATFORM_MAX_PATH];
	Format(sPath, sizeof(sPath), "sound/%s", sFile);
	PrecacheSound(sFile, true);
	AddFileToDownloadsTable(sPath);
}

public Action:NoWeaponCheck(Handle:timer, any:client)
{
	if(IsClientInGame(client) && IsPlayerAlive(client))
	{
		new weapons = 0;
		for(new slot = 0; slot <= 4; slot++)
		{
			if(GetPlayerWeaponSlot(client,slot) != -1)
			{
				weapons++;
			}
		}
		if(weapons == 0)
		{
			GivePlayerItem(client, "weapon_thompson");
			PrintToChat(client, " !!!! SORRY - YOU FOUND THE WEAPON BUG !!!! ");
			LogMessage("GG Weapon Bug 1 - spawn - Player %N", client);
		}
	}
}

public Action:NoWeaponCheck_remove(Handle:timer, any:client)
{
	if(IsClientInGame(client) && IsPlayerAlive(client))
	{
		new weapons = 0;
		for(new slot = 0; slot <= 4; slot++)
		{
			if(GetPlayerWeaponSlot(client,slot) != -1)
			{
				weapons++;
			}
		}
		if(weapons == 0)
		{
			GivePlayerItem(client, "weapon_thompson");
			PrintToChat(client, " !!! SORRY - YOU FOUND THE WEAPON BUG 2 !!! ");
			LogMessage("GG Weapon Bug 2 - ingame Player %N", client);
		}
	}
}

public Action:NoWeaponCheck_remove_giveweapon(Handle:timer, any:client)
{
	if(IsClientInGame(client) && IsPlayerAlive(client))
	{
		new weapons = 0;
		for(new slot = 0; slot <= 4; slot++)
		{
			if(GetPlayerWeaponSlot(client,slot) != -1)
			{
				weapons++;
			}
		}
		if(weapons == 0)
		{
			GivePlayerItem(client, "weapon_thompson");
			PrintToChat(client, " !!! SORRY - YOU FOUND THE WEAPON BUG 3 !!! ");
			LogMessage("GG Weapon Bug 3 - ingame give weapon Player %N", client);
			g_iLevel[client]--;
		}
	}
}

public Action:NoWeaponCheck_CLIP(Handle:timer, any:client)
{
	if(IsClientInGame(client) && IsPlayerAlive(client))
	{
		new weapons = 0;
		for(new slot = 0; slot <= 4; slot++)
		{
			if(GetPlayerWeaponSlot(client,slot) != -1)
			{
				weapons++;
			}
		}
		if(weapons == 0)
		{
			GivePlayerItem(client, "weapon_thompson");
			PrintToChat(client, " !!!! SORRY - YOU FOUND THE WEAPON BUG !!!! ");
			LogMessage("GG Weapon Bug - CLIP !!");
		}
	}
}

public OnMapEnd()
{
	LogMessage("GUNGAME MAP END");
}

public IsValidClient(client)
{
   if ( !( 1 <= client <= MaxClients ) || !IsClientInGame(client) )
        return false;

   return true;
}